	new;
	cls;
	format /rd/m1 8,4;

//=============================================================================
//	load data: level 3
//=============================================================================
	r = xlsreadm("core","b2:bu135",1,""); // 1997/01 -- 2008/02
	w = xlsreadm("core","b2:bu14",2,""); // 1996 -- 2008
	T = rows(r); // scalar
	for i (1,13,1);
		wi = w[i,.];
		wi = wi/sumc(packr(wi'));
		w[i,.] = wi;
	endfor;
	w = w.*.ones(12,1);
	w = w[1:T,.]; // 1996/01 -- 2007/02

//	==========================================================================
//		INF, RPV, RPS and REGIME
//	==========================================================================
	inf = zeros(T,1); // INF, Tx1
	rpv = zeros(T,1); // RPV, Tx1
	rps = zeros(T,1); // RPS, Tx1
	for i (1,T,1);
		wi = w[i,.]'; // Tx1
		ri = r[i,.]'; // Tx1
		infi = sumc(packr(wi.*ri)); // inflation
		rpvi = sqrt(sumc(packr(wi.*((ri-infi).^2)))); // rpv
		rpsi = sumc(packr(wi.*((ri-infi).^3)))/(rpvi^3); // rps
		inf[i] = infi;
		rpv[i] = rpvi;
		rps[i] = rpsi;
	endfor;
	avginf = meanc(inf);
	regime = (inf .< avginf);

//	==========================================================================
//		SAVE RESULTS
//	==========================================================================
	xlswritem(inf~rpv~rps~regime,"moment.xlsx","A2",1,"");
	
end;