	new ;
	cls ;
	#include FINF.SRC ;
	format /rd/m1 8,4 ;
	
	data = xlsreadm("distribution","A2:D1025",1,"");
	x = data[.,1]; // nx1
	f0 = data[.,2]; // nx1, actual
	f1 = data[.,3]; // nx1, dgp 1
	f2 = data[.,4]; // nx1, dgp 2

//	===========================================================================
//	ACTUAL DENSITY FUNCTION
//	===========================================================================
	m0 = RSUM(x,x.*f0) ;
	v0 = RSUM(x,((x-m0).^2).*f0) ;
	s0 = RSUM(x,((x-m0).^3).*f0)/(sqrt(v0)^3) ;
	k0 = RSUM(x,((x-m0).^4).*f0)/(v0^2) - 3 ;

//	===========================================================================
//	DGP1
//	===========================================================================
	m1 = RSUM(x,x.*f1) ;
	v1 = RSUM(x,((x-m1).^2).*f1) ;
	s1 = RSUM(x,((x-m1).^3).*f1)/(sqrt(v1)^3) ;
	k1 = RSUM(x,((x-m1).^4).*f1)/(v1^2) - 3 ;
	{dh1,dhav1,du1,de1} = GERROR(f0,f1,x) ;

//	===========================================================================
//	DGP 2
//	===========================================================================
	m2 = RSUM(x,x.*f2) ;
	v2 = RSUM(x,((x-m2).^2).*f2) ;
	s2 = RSUM(x,((x-m2).^3).*f2)/(sqrt(v2)^3) ;
	k2 = RSUM(x,((x-m2).^4).*f2)/(v2^2) - 3 ;
	{dh2,dhav2,du2,de2} = GERROR(f0,f2,x) ;
	
	moments = (m0|v0|s0|k0)~(m1|v1|s1|k1)~(m2|v2|s2|k2);
	xlswritem(moments,"distribution.xlsx","B2",2,"");

	distances = (dh1|dhav1|du1|de1)~(dh2|dhav2|du2|de2);
	xlswritem(distances,"distribution.xlsx","B2",3,"");
	
end ;
