new ;
cls ;
#include C:\MJKIM2008\FAR\INF\PRG\UK\STATS\FINF.SRC ;
library pgraph ;
chdir C:\MJKIM2008\FAR\INF\DAT\UK ;
format /rd/m1 8,4 ;

/******************************************************************************
                                 Load Data
*******************************************************************************/
INFR3 = xlsreadm("ukcpirL3","b1:ch134",1,"") ; // 1997/01 -- 2008/02
TID = xlsreadm("ukcpirL3","a1:a134",1,"") ; // 1997/01 -- 2008/02
T = rows(INFR3) ;
N = cols(INFR3) ;
WSTAR3 = xlsreadm("ukcpirL3","b1:ch13",2,"") ;
WSTAR3 = WSTAR3.*.ones(12,1) ;
WSTAR3 = WSTAR3[1:T,.]/1000 ; // 1996/01 ~ 2007/02
SNAME = xlsreadsa("ukcpirL3","a1:a85",3,"") ;
NID = seqa(1,1,N) ;

/******************************************************************************
                                Preliminaries
*******************************************************************************/
st = 199701 ; // start date
et = 200802 ; // end date
let string hd = { "nobs" "mean" "median" "maximum" "minimum" "standard deviation" 
"skewness" "kurtosis" "Jarque-Berra statistics" "p-value" "maxsector" "maxweight" "minsector" "minweight" } ;

/******************************************************************************
                      Descriptive Statistics for Each Time
*******************************************************************************/
ST1 = zeros(T,10) ; // Tx10
ST2 = zeros(T,2) ; // Tx2
let string maxname = "" ;
let string minname = "" ;
for i (1,T,1) ;
	xi = packr(INFR3[i,.]'~NID) ; // T(i)x2
	{ni,mi,medi,maxi,mini,stdi,si,ki,jbi,pvi} = stats(xi[.,1]) ;
	ST1[i,.] = ni~mi~medi~maxi~mini~stdi~si~ki~jbi~pvi ;
	r1 = xi[indexcat(xi[.,1],maxi),2] ;
	r2 = xi[indexcat(xi[.,1],mini),2] ;
	r1 = r1[1] ;
	r2 = r2[1] ;
	maxnamei = SNAME[r1] ;
	minnamei = SNAME[r2] ;
	maxname = maxname$|maxnamei ;
	minname = minname$|minnamei ;
	ST2[i,.] = WSTAR3[i,r1 r2] ;
endfor ;
maxname = maxname[2:T] ;
minname = minname[2:T] ;

chdir C:\MJKIM2008\FAR\INF\OUT\UK ;
xlswritesa(hd,"STATS","A1",2,"") ;
xlswritem(TID~ST1,"STATS","A2",2,"") ;
xlswritesa(maxname,"STATS","L2",2,"") ;
xlswritem(ST2[.,1],"STATS","M2",2,"") ;
xlswritesa(minname,"STATS","N2",2,"") ;
xlswritem(ST2[.,2],"STATS","O2",2,"") ;

/******************************************************************************
                      Descriptive Statistics for Each Sector
*******************************************************************************/
ST = zeros(N,10) ; // Tx10
for i (1,N,1) ;
	xi = packr(INFR3[.,i]) ; // T(i)x1
	{ni,mi,medi,maxi,mini,stdi,si,ki,jbi,pvi} = stats(xi) ;
	ST[i,.] = ni~mi~medi~maxi~mini~stdi~si~ki~jbi~pvi ;
endfor ;
xlswritesa(hd,"STATS","B1",1,"") ;
xlswritem(ST,"STATS","B2",1,"") ;

end ;
