new ;
cls ;
#include FINF.SRC ;
format /rd/m1 8,4 ;
stime = time ;

//=============================================================================
//	preliminaries
//=============================================================================
	st = 199701 ;	// start date
	et = 200802 ;	// end date

//=============================================================================
//	data
//=============================================================================
	loadm denf,tic,tid;
	f = denf;
	x = tic ;
	d = tid ;	

//=============================================================================
//	mean, variance, skewness and kurtosis
//=============================================================================
	T = rows(f) ;
	N = cols(f) ;
	m = zeros(T,1) ;
	v = zeros(T,1) ;
	s = zeros(T,1) ;
	k = zeros(T,1) ;	
	for i (1,T,1) ;
		fi = f[i,.]' ;
		mi = RSUM(x,x.*fi) ; m[i] = mi ;
		vi = RSUM(x,((x-mi).^2).*fi) ; v[i] = vi ;
		si = RSUM(x,((x-mi).^3).*fi)/(sqrt(vi)^3) ; s[i] = si ;
		ki = RSUM(x,((x-mi).^4).*fi)/(vi^2) - 3 ; k[i] = ki ;
	endfor ;
	mom = m~v~s~k ;
	let string hdr = { "mean" "variance" "skewness" "kurtosis" } ;
	xlswritesa(hdr,"moment.xlsx","B1",1,"") ;
	xlswritem(mom,"moment.xlsx","B2",1,"") ;
			
etime = time ;
? ; "Starting at: " stime' ;
? ; "  Ending at: " etime' ;

end ;
