new;
cls;
#include FINF.SRC;
format /rd/m1 8,4;

//	===========================================================================
//	Preliminaries
//	===========================================================================
	ng = 1024; // number of grid
	h = 1.06; // bandwidth
	lb = -6.0; // scalar
	ub = 6.0; // scalar
	
//	===========================================================================
//	load data: level 3
//	===========================================================================
	infr = xlsreadm("ukcpirL3","b1:ch134",1,""); // TxN, 1997/01 -- 2008/02
	tid = xlsreadm("ukcpirL3","a1:a134",1,""); // Tx1, 1997/01 -- 2008/02		
	T = rows(infr); // scalar
	N = cols(infr); // scalar

//	===========================================================================
//	cross-sectional distribution
//	===========================================================================
	lb = minc(minc(infr)) ;
	ub = maxc(maxc(infr)) ;
	dt = (ub-lb)/(ng-1); // scalar
	tic = seqa(lb-dt,dt,ng); // ngx1
	f = zeros(T,ng); // Txng
	for i (1,T,1);
		ri = packr(infr[i,.]'); // Nx1
		fi = PDF2(ri,h,tic); // ngx1
		f[i,.] = fi'; // 1xng
	endfor;
	ef = meanc(f); // ngx1
	{x,cef} = crsum(tic,ef); // (ng-1)x1
	xlswritem(x~cef,"cdf.xlsx","A2",1,"");

//	===========================================================================
//	standardised price change
//	===========================================================================
	z = zeros(T,N); // TxN
	for i (1,T,1);
		ri = infr[i,.]'; // Nx1
		rmi = meanc(packr(ri)); // scalar
		rsi = stdc(packr(ri)); // scalar
		zi = (ri-rmi)/rsi; // Nx1
		z[i,.] = zi'; // 1xN
	endfor;

//	===========================================================================
//	cross-sectional distribution
//	===========================================================================
	lb = -6;
	ub = 6;
	dt = (ub-lb)/(ng-1); // scalar
	tic = seqa(lb-dt,dt,ng); // ngx1
	f = zeros(T,ng); // Txng
	for i (1,T,1);
		zi = packr(z[i,.]'); // Nx1
		fi = PDF2(zi,h,tic); // ngx1
		f[i,.] = fi'; // 1xng
	endfor;
	ef = meanc(f); // ngx1
	{x,cef} = crsum(tic,ef); // (ng-1)x1
	xlswritem(x~cef,"cdf.xlsx","A2",2,"");

end;